from math import pi, cos

EARTH = 6378.137  # Radius of the earth in kilometer
METER = (1 / ((2 * pi / 360) * EARTH)) / 1000  # 1 meter in degree
OFFSET = 20  # Offset in meters


def calculate_corners(lat, lng):
    # From https://stackoverflow.com/questions/7477003/calculating-new-longitude-latitude-from-old-n-meters
    # Formulas:
    lat_pos = lat + (OFFSET * METER)
    lng_pos = lng + (OFFSET * METER) / cos(lat * (pi / 180))

    lat_neg = lat - (OFFSET * METER)
    lng_neg = lng - (OFFSET * METER) / cos(lat * (pi / 180))

    return [
        (lat_neg, lng_pos),
        (lat_pos, lng_pos),
        (lat_pos, lng_neg),
        (lat_neg, lng_neg)
    ]

# def div_measurement():
